<template>
    <div ref="scrollContainer" class="scroll-container w-100">
      <!-- Pull to refresh -->
      <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
      
      <!-- Page content -->
      <div class="container mx-auto p-5 mb-12">
        <!-- Page title -->
        <PageTitle title="Activities" />

        <Alert v-if="showError" type="error" title="Error" :body="errorText" />

        <!-- List of activities -->
        <GenericWidget v-for="item in list"
          :itemId="item.id"
          :itemName="item.name"
          itemType="activity"
          :itemStatus="item.status"
          :itemDescription="item.description"
          :itemDevice="item.device.name"
          @updateStatus= "toggleStatus"
          @editEvent="openEditModal" 
          @deleteEvent="openDeleteModal"
          @clickEvent="navigateToConditions(item)"
        ></GenericWidget>
      
        <!-- Loading -->
      <div v-if="loading">
          <div class="skeleton h-32 w-full flex flex-col justify-center">
            <button class="">
              <span class="loading loading-spinner"></span>
              Fetching Activities...
            </button>
          </div>
      </div>
        
      </div>
      
      <!-- Modal -->
      <Modal id="activity" :modalData="modalData" @onSubmit="handleSubmit" @closeModal="closeModal" />

      <!-- Add Create Activity button -->
      <FloatingActionButton @click="openCreateModal" />
    </div>
</template>

<script>
    import GenericWidget from '@/components/GenericWidget.vue';
    import PullToRefresh from '@/components/PullToRefresh.vue';
    import PageTitle from '@/components/PageTitle.vue';
    import FloatingActionButton from '@/components/FloatingActionButton.vue';
    import Modal from '@/components/Modal.vue';
    import Alert from '@/components/Alert.vue';

    import ROOMS from '@/assets/rooms.json';
    import ICONS from '@/assets/icons.json';

    const STATUS_TYPES = [
        { text: 'Active', value: 'active' },
        { text: 'Inactive', value: 'inactive' }
    ];
    
    export default {
        props: {
            routineId: { type: String, required: true },
        },
        components: {   
            GenericWidget,
            PullToRefresh,
            PageTitle,
            FloatingActionButton,
            Modal,
            Alert
        },
        data() {
            return {
                list: [], // array of items
                devices: [],
                scrollContainer: {}, // useful element for pull-to-refresh

                // props for modal component...
                modalData: {},
                showError: false,
                loading: false
            };
        },
        mounted() {
            // prepare the pull-to-refresh
            this.scrollContainer = this.$refs.scrollContainer
            this.$refs.pullRefresh.init()
            
            // Access routineId from the route parameters
            const routineId = parseInt(this.$route.params.routineId);
            this.fetchDevices();
            this.fetchData();
        },
        methods: {
            fetchDevices() {
                // Fetching the list of devices
                var self = this;
                self.$axios.get(`/devices`)
                .then(function (response) {
                    // handle success
                    self.showError = false
                    // Format the devices list
                    self.devices = response.data.map(device => ({
                        text: device.name,
                        value: device.id
                    }));
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.errorText = 'Devices not found, connect some devices first!';
                });
                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            fetchData() {
                // Fetching the list of routines
                var self = this;
                self.loading = true;
                self.$axios.get(`activities/findByRoutine?routineId=${this.routineId}`)
                .then(function (response) {
                    // handle success
                    self.showError = false
                    self.list = response.data;
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.errorText = error.response.data.message;
                })
                .finally(function () {
                    // always executed
                    self.loading = false;
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            create(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()
                var self = this;
                self.$axios.post('/activities', {
                    name: item.activityName,
                    status: 'active',
                    nextDeviceStatus: item.nextDeviceStatus,
                    andConditions: item.andConditions, 
                    deviceId: item.deviceId,
                    routineId: this.routineId,
                    description: item.activityDescription
                })
                .then(function (response) {
                    // handle success
                    self.list.push(response.data);
                    self.$toast.success("Routine created successfully!");
                })
                .catch(function (error) {
                    // handle error
                    console.log(error);
                    self.showError = true;
                    self.$toast.error(error.response.data.message);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            edit(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()
                
                console.log(item);
                // TODO: PUT /routines
                var self = this;
                self.$axios.put('/activities', {
                    id: item.activityId,
                    name: item.activityName,
                    status: 'active',
                    nextDeviceStatus: item.nextDeviceStatus,
                    andConditions: item.andConditions, 
                    deviceId: item.deviceId,
                    routineId: this.routineId,
                    description: item.activityDescription
                })
                .then(async (response) => {
                    // handle success
                    this.fetchData();
                    self.$toast.success("Activity updated successfully!");
                })
                .catch(function (error) {
                    // handle error
                    console.log(error);
                    self.showError = true;
                    self.$toast.error(error);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            remove(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()

                var self = this;
                self.$axios.delete("/activities", {
                    data: {
                        id: item.activityId
                    }
                })
                .then(async (response) => {
                    // handle success
                    this.fetchData();
                    self.$toast.success("Activity deleted successfully!");
                })
                .catch(function (error) {
                    // handle error
                    console.log(error);
                    self.showError = true;
                    self.$toast.error(error.response.data.message);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            toggleStatus(newData) {
                console.log(newData)
                // TODO: PUT /routines
                var self = this;
                self.$axios.put('/activities', newData)
                .then(async function (response) {
                    // handle success
                    self.$toast.success("Status updated successfully!");
                }).catch(function (error) {
                    self.$toast.error(error.response.data.message);
                });
            },
            navigateToConditions(activity) {
                // Use the router to navigate to Activities.vue with routineId as a route parameter
                this.$router.push({
                name: "Conditions",
                params: { 
                    activityId: activity.id
                },
                });
            },
            openCreateModal() {
                this.modalData = {
                    id: "createActivity",
                    title: "Create Activity",
                    text: "Fill all the fields in this form to create an activity.",
                    fields: [
                        {
                            label: 'Name',
                            type: 'input',
                            placeholder: 'Activity Name (e.g. Start Washing Machine)',
                            value: '',
                            required: true,
                            id: 'activityName',
                        },
                        {
                            label: 'Description',
                            type: 'textarea',
                            placeholder: 'Activity Description (e.g. Start the washing machine in 30 minutes..',
                            value: '',
                            required: true,
                            id: 'activityDescription',
                        },
                        {
                            label: 'Next Device Status',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'nextDeviceStatus',
                            value: '-1',
                            items: STATUS_TYPES
                        },
                        {
                            label: 'Select device',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,                            
                            value: "-1",
                            items: this.devices,
                            id: 'deviceId'
                        },
                        {
                            label: 'And Conditions',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,                            
                            value: "-1",
                            items: [
                                { text: 'True' , value: true },
                                { text: 'False' , value: false }
                            ],
                            id: 'andConditions'
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "create"
                }
                // opens the (creation) form
                activity.showModal()
            },
            openEditModal(item) {
                // forms for item deletion
                this.modalData = {
                    id: "editActivity",
                    title: "Edit Activity",
                    text: "Change the fields you want to edit and click confirm to save the changes.",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.itemId,
                            required: true,
                            id: 'activityId',
                        },
                        {
                            label: 'Change Name',
                            type: 'input',
                            placeholder: item.itemName,
                            value: item.itemName,
                            required: false,
                            id: 'activityName',
                        },
                        {
                            label: 'Change Description',
                            type: 'input',
                            placeholder: item.itemDescription,
                            value: item.itemDescription,
                            required: false,
                            id: 'activityDescription',
                        },
                        {
                            label: 'Next Device Status',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'nextDeviceStatus',
                            value: item.nextDeviceStatus,
                            items: STATUS_TYPES
                        },
                        {
                            label: 'Select device',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,                            
                            value: item.deviceId,
                            items: this.devices,
                            id: 'deviceId'
                        },
                        {
                            label: 'All conditions must be true',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,                            
                            value: item.andConditions,
                            items: [
                                { text: 'True' , value: true },
                                { text: 'False' , value: false }
                            ],
                            id: 'andConditions'
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "edit"
                };
                activity.showModal();
            },
            openDeleteModal(item) {
                // forms for item deletion
                this.modalData = {
                    id: "deleteActivity",
                    title: "Delete Activity",
                    text: "Are you sure you want to delete this activity?",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.itemId,
                            required: true,
                            id: 'activityId',
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "remove"
                };
                activity.showModal();
            },
            closeModal() {
                activity.close()
            },
            handleSubmit(data){
                this[this.modalData.onSubmit](data)
            },
            goBack() {
                this.$router.go(-1);
            }
        }
    }
</script>